Index: trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 964)
+++ trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 976)
@@ -610,8 +610,6 @@
     memset( m_apSegmentDCOffset[1]  + firstElement,     0,                numElements * sizeof( *m_apSegmentDCOffset[1] ) );
 #endif
-#if HS_DMM_SDC_PREDICTOR_UNIFY_H0108
     m_apDmmPredictor[0] = 0;
     m_apDmmPredictor[1] = 0;
-#endif
 #endif
 #if H_3D_DBBP
@@ -788,8 +786,6 @@
       m_apSegmentDCOffset[1][ui] = 0;
 #endif
-#if HS_DMM_SDC_PREDICTOR_UNIFY_H0108
       m_apDmmPredictor[0] = 0;
       m_apDmmPredictor[1] = 0;
-#endif
 #endif
 #if H_3D_DBBP
@@ -907,8 +903,6 @@
   memset( m_apSegmentDCOffset[1], 0, sizeof(Pel) * m_uiNumPartition   );
 #endif
-#if HS_DMM_SDC_PREDICTOR_UNIFY_H0108
   m_apDmmPredictor[0] = 0;
   m_apDmmPredictor[1] = 0;
-#endif
 #endif
 #if H_3D_DBBP
@@ -2364,10 +2358,8 @@
     
     TComMv cDv = depthRefineFlag ? DvInfo.m_acDoNBDV : DvInfo.m_acNBDV;
-#if SEC_VER_DONBDV_H0103
     if( depthRefineFlag )
     {
       cDv.setVer(0);
     }
-#endif
     
     Int depthPosX = Clip3(0,   iPictureWidth - iWidth,  iBlkX + ((cDv.getHor()+2)>>2));
@@ -2399,24 +2391,4 @@
 }
 
-UInt TComDataCU::getCtxAngleFlag( UInt uiAbsPartIdx )
-{
-#if LGE_SIMP_DIM_NOT_PRESENT_FLAG_CODING_H0119_H0135
-  return 0;
-#else
-  TComDataCU* pcTempCU;
-  UInt        uiTempPartIdx;
-  UInt        uiCtx = 0;
-
-  // Get BCBP of left PU
-  pcTempCU = getPULeft( uiTempPartIdx, m_uiAbsIdxInLCU + uiAbsPartIdx );
-  uiCtx    = ( pcTempCU && pcTempCU->isIntra( uiTempPartIdx ) ) ? ( pcTempCU->getLumaIntraDir( uiTempPartIdx ) < NUM_INTRA_MODE ? 1 : 0 ) : 0;
-
-  // Get BCBP of above PU
-  pcTempCU = getPUAbove( uiTempPartIdx, m_uiAbsIdxInLCU + uiAbsPartIdx );
-  uiCtx   += ( pcTempCU && pcTempCU->isIntra( uiTempPartIdx ) ) ? ( pcTempCU->getLumaIntraDir( uiTempPartIdx ) < NUM_INTRA_MODE ? 1 : 0 ) : 0;
-
-  return uiCtx;
-#endif
-}
 #endif
 
@@ -3280,10 +3252,5 @@
  *   false: otherwise
  */
-#if ETRIKHU_CLEANUP_H0083
 inline Bool TComDataCU::xAddVspCand( Int mrgCandIdx, DisInfo* pDInfo, Int& iCount)
-#else
-inline Bool TComDataCU::xAddVspCand( Int mrgCandIdx, DisInfo* pDInfo, Int& iCount,
-  Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* vspFlag, Int& iCount3DV, InheritedVSPDisInfo*  inheritedVSPDisInfo  )
-#endif
 {
   if ( m_pcSlice->getViewIndex() == 0 || !m_pcSlice->getVPS()->getViewSynthesisPredFlag( m_pcSlice->getLayerIdInVps() ) || m_pcSlice->getIsDepth() || pDInfo->m_aVIdxCan == -1)
@@ -3301,11 +3268,6 @@
   }
 
-#if ETRIKHU_CLEANUP_H0083
   TComMvField mvVSP[2];
   UChar dirVSP;
-#else
-  rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, (5-iCount), iCount3DV);
-#endif
-
   Bool  refViewAvailFlag = false;
   UChar predFlag[2]      = {0, 0};
@@ -3321,29 +3283,14 @@
         refViewAvailFlag      = true;
         predFlag[iRefListIdX] = 1;
-#if ETRIKHU_CLEANUP_H0083
         mvVSP[0+iRefListIdX].setMvField( pDInfo->m_acNBDV, i );
 #if H_3D_NBDV
         mvVSP[0+iRefListIdX].getMv().setIDVFlag (false);
 #endif
-#else
-        pcMvFieldNeighbours[(iCount<<1)+iRefListIdX].setMvField( pDInfo->m_acNBDV, i );
-#if H_3D_NBDV
-        pcMvFieldNeighbours[(iCount<<1)+iRefListIdX].getMv().setIDVFlag (false);
-#endif
-#endif
-      }
-    }
-  }
-
-#if ETRIKHU_CLEANUP_H0083
+      }
+    }
+  }
+
   dirVSP = (predFlag[0] | (predFlag[1] << 1));
   m_mergCands[MRG_VSP].setCand( mvVSP, dirVSP, true, false);
-#else
-  // Set values to be returned
-  abCandIsInter        [iCount] = true;
-  puhInterDirNeighbours[iCount] = (predFlag[0] | (predFlag[1] << 1));
-  vspFlag              [iCount] = 1;
-#endif
-
   if ( mrgCandIdx == iCount )
   {
@@ -3359,10 +3306,5 @@
 
 #if H_3D_IV_MERGE
-#if ETRIKHU_CLEANUP_H0083
 inline Bool TComDataCU::xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Int* ivCandDir, TComMv* ivCandMv, Int* ivCandRefIdx )
-#else
-inline Bool TComDataCU::xAddIvMRGCand( Int mrgCandIdx, Int& iCount, Bool* abCandIsInter, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* ivCandDir, TComMv* ivCandMv, 
-  Int* ivCandRefIdx, Int iPosIvDC, Int* vspFlag, Int &iCount3DV, InheritedVSPDisInfo*  inheritedVSPDisInfo  )
-#endif
 {
   for(Int iLoop = 0; iLoop < 2; iLoop ++ ) 
@@ -3372,19 +3314,11 @@
     {
       Int iFirDispCand = -1;
-#if ETRIKHU_CLEANUP_H0083
       TComMvField mvIvDcShift[2];
       UChar dirIvDcShift;
 
       if (xGetPosFirstAvailDmvCand(MRG_IVSHIFT, iFirDispCand))
-#else
-      if (xGetPosFirstAvailDmvCand(iCount, pcMvFieldNeighbours, ivCandDir, iPosIvDC, vspFlag, iFirDispCand))
-#endif
       {
         TComMv cMv;
-#if ETRIKHU_CLEANUP_H0083
         cMv = m_mergCands[iFirDispCand].m_cMvField[0].getMv();
-#else
-        cMv = pcMvFieldNeighbours[(iFirDispCand<<1)].getMv();
-#endif
         cMv.setHor(cMv.getHor()+4);
         if(m_pcSlice->getVPS()->getViewSynthesisPredFlag(m_pcSlice->getLayerIdInVps()))
@@ -3396,17 +3330,8 @@
 #endif
 
-#if ETRIKHU_CLEANUP_H0083
         dirIvDcShift = m_mergCands[iFirDispCand].m_uDir;
         mvIvDcShift[0].setMvField(cMv, m_mergCands[iFirDispCand].m_cMvField[0].getRefIdx() );
         mvIvDcShift[1].setMvField(m_mergCands[iFirDispCand].m_cMvField[1].getMv(), m_mergCands[iFirDispCand].m_cMvField[1].getRefIdx() );
         m_mergCands[MRG_IVSHIFT].setCand(mvIvDcShift, dirIvDcShift, false, false);
-#else
-        rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, (5-iCount), iCount3DV);
-
-        abCandIsInter        [ iCount ] = true;
-        puhInterDirNeighbours[ iCount ] = puhInterDirNeighbours[iFirDispCand];
-        pcMvFieldNeighbours  [ iCount << 1      ].setMvField(cMv, pcMvFieldNeighbours[( iFirDispCand << 1)].getRefIdx() );
-        pcMvFieldNeighbours  [(iCount << 1) + 1 ].setMvField(pcMvFieldNeighbours[(iFirDispCand << 1) + 1].getMv(), pcMvFieldNeighbours[( iFirDispCand << 1) + 1].getRefIdx() );
-#endif
         
         if( mrgCandIdx == iCount ) 
@@ -3414,5 +3339,4 @@
           return true;
         }
-
         iCount++;
         break;
@@ -3439,9 +3363,5 @@
       if( !iLoop && ivCandDir[0] > 0)
       {
-#if ETRIKHU_CLEANUP_H0083
         if(tmpDir == m_mergCands[MRG_IVMC].m_uDir && m_mergCands[MRG_IVMC].m_cMvField[0]==tmpMV[0] && m_mergCands[MRG_IVMC].m_cMvField[1]==tmpMV[1])
-#else
-        if(tmpDir == puhInterDirNeighbours[0] && pcMvFieldNeighbours[0]==tmpMV[0] && pcMvFieldNeighbours[1]==tmpMV[1])
-#endif
         {
             bRemove                         = true;
@@ -3450,5 +3370,4 @@
       if(!bRemove)
       {
-#if ETRIKHU_CLEANUP_H0083
 #if H_3D_NBDV
         if(iLoop) // For IvMcShift candidate
@@ -3459,25 +3378,4 @@
 #endif
         m_mergCands[MRG_IVSHIFT].setCand(tmpMV, tmpDir, false, false);
-#else
-        rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, (5-iCount), iCount3DV);
-
-        abCandIsInter[ iCount ] = true;
-        puhInterDirNeighbours[ iCount ] = ivCandDir[iLoop + 2];
-        if( ( ivCandDir[iLoop + 2] & 1 ) == 1 )
-        {
-          pcMvFieldNeighbours[ iCount<<1 ].setMvField( ivCandMv[ (iLoop<<1) + 4 ], ivCandRefIdx[ (iLoop<<1) + 4 ] ); 
-        }
-        if( ( ivCandDir[iLoop + 2] & 2 ) == 2 )
-        {
-          pcMvFieldNeighbours[ (iCount<<1)+1 ].setMvField( ivCandMv[ (iLoop<<1) + 5 ], ivCandRefIdx[ (iLoop<<1) + 5 ] );
-        }
-#if H_3D_NBDV
-        if(iLoop) // For IvMcShift candidate
-        {
-          pcMvFieldNeighbours[iCount<<1    ].getMv().setIDVFlag (false);
-          pcMvFieldNeighbours[(iCount<<1)+1].getMv().setIDVFlag (false);
-        }
-#endif
-#endif
         if( mrgCandIdx == iCount )
         {
@@ -3492,5 +3390,4 @@
 } 
 
-#if ETRIKHU_CLEANUP_H0083
 inline Bool TComDataCU::xGetPosFirstAvailDmvCand(Int iCount, Int& posFirstAvailDmvCand )
 {
@@ -3509,29 +3406,8 @@
   return false;  
 }
-#else
-inline Bool TComDataCU::xGetPosFirstAvailDmvCand( Int iCount, TComMvField* pcMvFieldNeighbours, Int* ivCandDir, Int posIvDC, Int* vspFlag, Int& posFirstAvailDmvCand )
-{
-  // ivCandDir[0] == true --> IvMC is available and excluded in loop over merge list. 
-  for ( Int currListPos = (ivCandDir[0] ? 1 : 0); currListPos < iCount; currListPos++ )
-  {
-    if ( ( currListPos == posIvDC ) || ( vspFlag[ currListPos ] != 0 ) )
-    {
-      continue;
-    }
-    else if((pcMvFieldNeighbours[currListPos<<1].getRefIdx() != -1 ) && (getSlice()->getViewIndex() != getSlice()->getRefPic(RefPicList(0), pcMvFieldNeighbours[currListPos<<1].getRefIdx())->getViewIndex()))
-    {
-      posFirstAvailDmvCand = currListPos;
-      return true;
-    }
-  }
- return false;  
-}
-#endif
                                       
 #endif
 
 #if H_3D
-#if ETRIKHU_CLEANUP_H0083
-
 Void TComDataCU::buildMCL(TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours
 #if H_3D_VSP
@@ -3606,26 +3482,4 @@
   assert(iCount == getSlice()->getMaxNumMergeCand());
 }
-#else
-Void TComDataCU::rightShiftMergeCandList( TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* iVSPIndexTrue, InheritedVSPDisInfo*  inheritedVSPDisInfo, UInt start, UInt num, Int &iCount3DV)
-{
-  iCount3DV++;
-  for (int i=num; i>0; i--)
-  {
-    pcMvFieldNeighbours[(start+i)<<1].setMvField(pcMvFieldNeighbours[(start+i-1)<<1].getMv(), pcMvFieldNeighbours[(start+i-1)<<1].getRefIdx());
-    pcMvFieldNeighbours[((start+i)<<1)+1].setMvField(pcMvFieldNeighbours[((start+i-1)<<1)+1].getMv(), pcMvFieldNeighbours[((start+i-1)<<1)+1].getRefIdx());
-    puhInterDirNeighbours[start+i] = puhInterDirNeighbours[start+i-1];
-    iVSPIndexTrue[start+i] = iVSPIndexTrue[start+i-1];
-    inheritedVSPDisInfo[start+i].m_acDvInfo   = inheritedVSPDisInfo[start+i-1].m_acDvInfo;
-  }
-  TComMv  cZeroMv;
-  pcMvFieldNeighbours[start<<1].setMvField( cZeroMv, NOT_VALID );
-  pcMvFieldNeighbours[(start<<1)+1].setMvField( cZeroMv, NOT_VALID );
-  puhInterDirNeighbours[start] = 0;
-  iVSPIndexTrue[start] = 0;
-  inheritedVSPDisInfo[start].m_acDvInfo = m_cDefaultDisInfo;
-
-  return;
-}
-#endif
 
 /** Constructs a list of merging candidates
@@ -4001,15 +3855,8 @@
 #endif
 #if H_3D_VSP
-#if !ETRIKHU_CLEANUP_H0083
-      , Int* vspFlag
-#endif
       , InheritedVSPDisInfo*  inheritedVSPDisInfo
 #endif
 #if H_3D_SPIVMP
-#if ETRIKHU_CLEANUP_H0083
       , TComMvField* pcMvFieldSP, UChar* puhInterDirSP
-#else
-      , Bool* pbSPIVMPFlag, TComMvField* pcMvFieldSP, UChar* puhInterDirSP
-#endif
 #endif
       , Int& numValidMergeCand, Int mrgCandIdx
@@ -4022,7 +3869,4 @@
   ////////////////////////////
   TComMv cZeroMv;
-#if !ETRIKHU_CLEANUP_H0083
-  Bool abCandIsInter[ MRG_MAX_NUM_CANDS_MEM ];
-#endif
 #else
   Bool abCandIsInter[ MRG_MAX_NUM_CANDS ];
@@ -4090,18 +3934,8 @@
 #if H_3D_DBBP
   Bool bDBBPFlag = getDBBPFlag(uiAbsPartIdx);
-#if MTK_DIS_SPBIP8X4_H0205
   assert(bDBBPFlag == getDBBPFlag(0));  
 #endif
-#endif
 
 #if H_3D
-#if !ETRIKHU_CLEANUP_H0083
-  Int  iPosLeftAbove[2] = {-1, -1};
-
-  Int iCountHEVC = 0;
-  Int iCount3DV = 0;
-  Int numA1B1B0 = 0;
-  Int numA0B2 = 0;
-#endif
 #if H_3D_NBDV
   for(Int i = 0; i < MRG_MAX_NUM_CANDS_MEM; i++)  
@@ -4111,9 +3945,4 @@
   }
 #endif
-
-
-#if ETRIKHU_CLEANUP_H0083
-
-
   // Clean version for MCL construction align with WD
   // init mergCands list
@@ -4142,5 +3971,5 @@
       && !bARPFlag
 #endif
-#if RWTH_DBBP_NO_SPU_H0057
+#if H_3D_DBBP
       && !bDBBPFlag
 #endif
@@ -4169,5 +3998,5 @@
       && !bARPFlag
 #endif
-#if RWTH_DBBP_NO_SPU_H0057
+#if H_3D_DBBP
       && !bDBBPFlag
 #endif
@@ -4196,5 +4025,5 @@
       && !bARPFlag
 #endif
-#if RWTH_DBBP_NO_SPU_H0057
+#if H_3D_DBBP
       && !bDBBPFlag
 #endif
@@ -4222,5 +4051,5 @@
       && !bARPFlag
 #endif
-#if RWTH_DBBP_NO_SPU_H0057
+#if H_3D_DBBP
       && !bDBBPFlag
 #endif
@@ -4249,5 +4078,5 @@
       && !bARPFlag
 #endif
-#if RWTH_DBBP_NO_SPU_H0057
+#if H_3D_DBBP
       && !bDBBPFlag
 #endif
@@ -4259,143 +4088,4 @@
   }
 
-
-#if !ETRIKHU_BUGFIX_H0083
-  Bool A1_was_available = m_mergCands[MRG_A1].m_bAvailable;
-  Bool B1_was_available = m_mergCands[MRG_B1].m_bAvailable;
-#endif
-
-
-#else
-  //left
-  UInt uiLeftPartIdx = 0;
-  TComDataCU* pcCULeft = 0;
-  pcCULeft = getPULeft( uiLeftPartIdx, uiPartIdxLB );  
-  if (getAvailableFlagA1())
-  {
-    iPosLeftAbove[0] = numA1B1B0;
-#if H_3D_VSP
-    if (pcCULeft->getVSPFlag(uiLeftPartIdx) != 0
-#if H_3D_IC
-      && !bICFlag
-#endif
-#if H_3D_ARP
-      && !bARPFlag
-#endif
-#if RWTH_DBBP_NO_SPU_H0057
-      && !bDBBPFlag
-#endif
-      )
-    {
-      vspFlag[numA1B1B0] = 1;
-    }
-#endif
-    numA1B1B0++;
-  }
-
-  // above
-  UInt uiAbovePartIdx = 0;
-  TComDataCU* pcCUAbove = 0;
-  pcCUAbove = getPUAbove( uiAbovePartIdx, uiPartIdxRT );
-  if ( getAvailableFlagB1())
-  {
-    iPosLeftAbove[1] = numA1B1B0;
-#if H_3D_VSP
-    if ( ( ( getAddr() - pcCUAbove->getAddr() ) == 0) && (pcCUAbove->getVSPFlag(uiAbovePartIdx) != 0) 
-#if H_3D_IC
-      && !bICFlag
-#endif
-#if H_3D_ARP
-      && !bARPFlag
-#endif
-#if RWTH_DBBP_NO_SPU_H0057
-      && !bDBBPFlag
-#endif
-      )
-    {
-      vspFlag[numA1B1B0] = 1;
-    }
-#endif
-
-    numA1B1B0++;
-  }
-
-  // above right
-  UInt uiAboveRightPartIdx = 0;
-  TComDataCU* pcCUAboveRight = 0;
-  pcCUAboveRight = getPUAboveRight( uiAboveRightPartIdx, uiPartIdxRT );
-  if ( getAvailableFlagB0())
-  {
-#if H_3D_VSP
-    if ( ( ( getAddr() - pcCUAboveRight->getAddr() ) == 0) && (pcCUAboveRight->getVSPFlag(uiAboveRightPartIdx) != 0) 
-#if H_3D_IC
-      && !bICFlag
-#endif
-#if H_3D_ARP
-      && !bARPFlag
-#endif
-#if RWTH_DBBP_NO_SPU_H0057
-      && !bDBBPFlag
-#endif
-      )
-    {
-      vspFlag[numA1B1B0] = 1;
-    }
-#endif
-    numA1B1B0++;
-  }
-  
-  // left bottom
-  UInt uiLeftBottomPartIdx = 0;
-  TComDataCU* pcCULeftBottom = getPUBelowLeft( uiLeftBottomPartIdx, uiPartIdxLB );
-  if ( getAvailableFlagA0())
-  {
-#if H_3D_VSP
-    if (pcCULeftBottom->getVSPFlag(uiLeftBottomPartIdx) != 0
-#if H_3D_IC
-      && !bICFlag
-#endif
-#if H_3D_ARP
-      && !bARPFlag
-#endif
-#if RWTH_DBBP_NO_SPU_H0057
-      && !bDBBPFlag
-#endif
-      )
-    {
-      vspFlag[numA1B1B0] = 1;
-    }
-#endif
-    iCountHEVC++;
-    numA0B2++;
-  }
-  
-  // above left
-  UInt uiAboveLeftPartIdx = 0;
-  TComDataCU* pcCUAboveLeft = 0;
-  pcCUAboveLeft = getPUAboveLeft( uiAboveLeftPartIdx, uiAbsPartAddr );
-  if (getAvailableFlagB2())
-  {
-#if H_3D_VSP
-    if ( ( ( getAddr() - pcCUAboveLeft->getAddr() ) == 0) && (pcCUAboveLeft->getVSPFlag(uiAboveLeftPartIdx) != 0) 
-#if H_3D_IC
-      && !bICFlag
-#endif
-#if H_3D_ARP
-      && !bARPFlag
-#endif
-#if RWTH_DBBP_NO_SPU_H0057
-      && !bDBBPFlag
-#endif
-      )
-    {
-      vspFlag[numA1B1B0+iCountHEVC] = 1;
-    }
-#endif
-    iCountHEVC++;
-    numA0B2++;
-  }
-
-  iCountHEVC = numValidMergeCand;
-#endif
 #endif
 
@@ -4407,7 +4097,5 @@
   /////////////////////////////////////////////
 
-#if SHARP_SIMPLE_MERGE_H0062
   bMPIFlag &= (nPSW + nPSH > 12);
-#endif
   if( bMPIFlag)
   {
@@ -4416,7 +4104,5 @@
     tmpDir        =  0;
 
-#if ETRIKHU_CLEANUP_H0083
     Bool bSPIVMPFlag = false;
-#endif
 
     TComPic * pcTexPic = m_pcSlice->getTexturePic();
@@ -4457,5 +4143,4 @@
       Int         iTexPosX, iTexPosY;
       const TComMv cMvRounding( 1 << ( 2 - 1 ), 1 << ( 2 - 1 ) );
-#if MPI_SUBPU_DEFAULT_MV_H0077_H0099_H0111_H0133
       
       Int         iCenterPosX = iCurrPosX + ( ( iWidth /  iPUWidth ) >> 1 )  * iPUWidth + ( iPUWidth >> 1 );
@@ -4476,38 +4161,30 @@
       if( pcDefaultCU->getPredictionMode( iTexCenterAbsPartIdx ) != MODE_INTRA )
       {
-          for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )
+        for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )
+        {
+          RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
+
+          TComMvField cDefaultMvField;
+          pcDefaultCU->getMvField( pcDefaultCU, iTexCenterAbsPartIdx, eCurrRefPicList, cDefaultMvField );
+          Int         iDefaultRefIdx     = cDefaultMvField.getRefIdx();
+          if (iDefaultRefIdx >= 0)
           {
-              RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
-
-              TComMvField cDefaultMvField;
-              pcDefaultCU->getMvField( pcDefaultCU, iTexCenterAbsPartIdx, eCurrRefPicList, cDefaultMvField );
-              Int         iDefaultRefIdx     = cDefaultMvField.getRefIdx();
-              if (iDefaultRefIdx >= 0)
+            Int iDefaultRefPOC = pcDefaultCU->getSlice()->getRefPOC(eCurrRefPicList, iDefaultRefIdx);
+            for (Int iRefPicList = 0; iRefPicList < m_pcSlice->getNumRefIdx( eCurrRefPicList ); iRefPicList++)
+            {
+              if (iDefaultRefPOC == m_pcSlice->getRefPOC(eCurrRefPicList, iRefPicList))
               {
-                  Int iDefaultRefPOC = pcDefaultCU->getSlice()->getRefPOC(eCurrRefPicList, iDefaultRefIdx);
-                  for (Int iRefPicList = 0; iRefPicList < m_pcSlice->getNumRefIdx( eCurrRefPicList ); iRefPicList++)
-                  {
-                      if (iDefaultRefPOC == m_pcSlice->getRefPOC(eCurrRefPicList, iRefPicList))
-                      {
-#if ETRIKHU_CLEANUP_H0083
-                        bSPIVMPFlag = true;
-#else
-                          pbSPIVMPFlag[iCount] = true;
-#endif
-                          TComMv cMv = cDefaultMvField.getMv() + cMvRounding;
-                          cMv >>= 2;
-                          clipMv( cMv );
-                          cMvFieldSaved[eCurrRefPicList].setMvField(cMv, iRefPicList) ;
-                          break;
-                      }
-                  }
+                bSPIVMPFlag = true;
+                TComMv cMv = cDefaultMvField.getMv() + cMvRounding;
+                cMv >>= 2;
+                clipMv( cMv );
+                cMvFieldSaved[eCurrRefPicList].setMvField(cMv, iRefPicList) ;
+                break;
               }
+            }
           }
-      }
-#if ETRIKHU_CLEANUP_H0083
+        }
+      }
       if ( bSPIVMPFlag == true )
-#else
-      if ( pbSPIVMPFlag[iCount] == true )
-#endif
       {   
           iInterDirSaved = (cMvFieldSaved[0].getRefIdx()!=-1 ? 1: 0) + (cMvFieldSaved[1].getRefIdx()!=-1 ? 2: 0);
@@ -4519,86 +4196,55 @@
       if ( iInterDirSaved != 0 )
       {
-#endif
-      for (Int i=iCurrPosY; i < iCurrPosY + iHeight; i += iPUHeight)
-      {
-        for (Int j = iCurrPosX; j < iCurrPosX + iWidth; j += iPUWidth)
+        for (Int i=iCurrPosY; i < iCurrPosY + iHeight; i += iPUHeight)
         {
-          iTexPosX     = j + iOffsetX;
-          iTexPosY     = i + iOffsetY; 
-          pcTexRec->getCUAddrAndPartIdx( iTexPosX, iTexPosY, iTexCUAddr, iTexAbsPartIdx );
-          pcTexCU  = pcTexPic->getCU( iTexCUAddr );
-
-          if( pcTexCU && !pcTexCU->isIntra(iTexAbsPartIdx) )
+          for (Int j = iCurrPosX; j < iCurrPosX + iWidth; j += iPUWidth)
           {
-            for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )
+            iTexPosX     = j + iOffsetX;
+            iTexPosY     = i + iOffsetY; 
+            pcTexRec->getCUAddrAndPartIdx( iTexPosX, iTexPosY, iTexCUAddr, iTexAbsPartIdx );
+            pcTexCU  = pcTexPic->getCU( iTexCUAddr );
+
+            if( pcTexCU && !pcTexCU->isIntra(iTexAbsPartIdx) )
             {
-              RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
-              TComMvField cTexMvField;
-              pcTexCU->getMvField( pcTexCU, iTexAbsPartIdx, eCurrRefPicList, cTexMvField );
-              Int iValidDepRef = getPic()->isTextRefValid( eCurrRefPicList, cTexMvField.getRefIdx() );
-              if( (cTexMvField.getRefIdx()>=0) && ( iValidDepRef >= 0 ) )
+              for( UInt uiCurrRefListId = 0; uiCurrRefListId < 2; uiCurrRefListId++ )
               {
-                TComMv cMv = cTexMvField.getMv() + cMvRounding;
-                cMv >>=2;          
+                RefPicList  eCurrRefPicList = RefPicList( uiCurrRefListId );
+                TComMvField cTexMvField;
+                pcTexCU->getMvField( pcTexCU, iTexAbsPartIdx, eCurrRefPicList, cTexMvField );
+                Int iValidDepRef = getPic()->isTextRefValid( eCurrRefPicList, cTexMvField.getRefIdx() );
+                if( (cTexMvField.getRefIdx()>=0) && ( iValidDepRef >= 0 ) )
+                {
+                  TComMv cMv = cTexMvField.getMv() + cMvRounding;
+                  cMv >>=2;          
 #if !(NTT_BUG_FIX_TK54)
-                this->clipMv( cMv );
-#endif
-                pcMvFieldSP[2*iPartition + uiCurrRefListId].setMvField(cMv, iValidDepRef);
-              }
-            }
-          }
-          puhInterDirSP[iPartition] = (pcMvFieldSP[2*iPartition].getRefIdx()!=-1 ? 1: 0) + (pcMvFieldSP[2*iPartition+1].getRefIdx()!=-1 ? 2: 0);
-          if (puhInterDirSP[iPartition] == 0)
-          {
-            if (iInterDirSaved != 0)
-            {
-              puhInterDirSP[iPartition] = iInterDirSaved;
-              pcMvFieldSP[2*iPartition] = cMvFieldSaved[0];
-              pcMvFieldSP[2*iPartition + 1] = cMvFieldSaved[1];
-            }
-          }
-#if MTK_DIS_SPBIP8X4_H0205
-              if (iPUHeight + iPUWidth == 12)
-              {
-                if (puhInterDirSP[iPartition] == 3)
-                {
-                  puhInterDirSP[iPartition] = 1;
-                  pcMvFieldSP[2*iPartition + 1].setMvField(TComMv(0,0), -1);
-                }
-              }
-#endif
-#if !MPI_SUBPU_DEFAULT_MV_H0077_H0099_H0111_H0133
-          else
-          {
-            if (iInterDirSaved ==0)
-            {
-#if ETRIKHU_CLEANUP_H0083
-                  bSPIVMPFlag = true;
-#else
-              pbSPIVMPFlag[iCount] = true;
-#endif
-              tmpDir = puhInterDirSP[iPartition];
-              tmpMV[0] = pcMvFieldSP[2*iPartition];
-              tmpMV[1] = pcMvFieldSP[2*iPartition+1];
-
-              if (iPartition != 0)
-              {
-                for (Int iPart = iPartition-1; iPart >= 0; iPart--)
-                {
-                  puhInterDirSP[iPart] = puhInterDirSP[iPartition];
-                  pcMvFieldSP[2*iPart] = pcMvFieldSP[2*iPartition];
-                  pcMvFieldSP[2*iPart + 1] = pcMvFieldSP[2*iPartition + 1];
+                  this->clipMv( cMv );
+#endif
+                  pcMvFieldSP[2*iPartition + uiCurrRefListId].setMvField(cMv, iValidDepRef);
                 }
               }
             }
-            iInterDirSaved = puhInterDirSP[iPartition];
-            cMvFieldSaved[0] = pcMvFieldSP[2*iPartition];
-            cMvFieldSaved[1] = pcMvFieldSP[2*iPartition + 1];
+            puhInterDirSP[iPartition] = (pcMvFieldSP[2*iPartition].getRefIdx()!=-1 ? 1: 0) + (pcMvFieldSP[2*iPartition+1].getRefIdx()!=-1 ? 2: 0);
+            if (puhInterDirSP[iPartition] == 0)
+            {
+              if (iInterDirSaved != 0)
+              {
+                puhInterDirSP[iPartition] = iInterDirSaved;
+                pcMvFieldSP[2*iPartition] = cMvFieldSaved[0];
+                pcMvFieldSP[2*iPartition + 1] = cMvFieldSaved[1];
+              }
+            }
+            if (iPUHeight + iPUWidth == 12)
+            {
+              if (puhInterDirSP[iPartition] == 3)
+              {
+                puhInterDirSP[iPartition] = 1;
+                pcMvFieldSP[2*iPartition + 1].setMvField(TComMv(0,0), -1);
+              }
+            }
+
+            iPartition ++;
           }
-#endif
-          iPartition ++;
         }
-      }
-#if MPI_SUBPU_DEFAULT_MV_H0077_H0099_H0111_H0133
+#if H_3D
       }
 #endif
@@ -4609,5 +4255,4 @@
     {
       Int iCnloop = 0;
-#if ETRIKHU_CLEANUP_H0083
       for(iCnloop = 0; iCnloop < 2; iCnloop ++)
       {
@@ -4624,65 +4269,4 @@
       m_mergCands[MRG_T].setCand( tmpMV, tmpDir, false, bSPIVMPFlag);
 
-#else
-      Bool bRemoveSpa = false; //pruning
-
-      for(Int i = 0; i < 2; i ++)
-      {
-        iCnloop = iPosLeftAbove[i];
-        if ( iCnloop == -1 ) 
-        {
-          continue;
-        }
-        if(tmpDir == puhInterDirNeighbours[iCnloop] && tmpMV[0]==pcMvFieldNeighbours[(iCnloop<<1)] && tmpMV[1]==pcMvFieldNeighbours[(iCnloop<<1)+1])
-        {
-          bRemoveSpa                      = true;
-          break;
-        }      
-      }
-
-      if (!bRemoveSpa)
-      {
-        rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, 5-iCount, iCount3DV);
-      }
-      else
-      {
-        rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, (iCnloop-iCount), iCount3DV);
-        if (iCnloop<numA1B1B0)
-        {
-          numA1B1B0--;
-        }
-        iCountHEVC--;
-
-        if (iPosLeftAbove[0] != -1)
-        {
-          if (iCnloop == iPosLeftAbove[0])
-          {
-            iPosLeftAbove[0] = -1;
-          }
-          else
-          {
-            iPosLeftAbove[0]++;
-          }
-        }
-        if (iPosLeftAbove[1] != -1)
-        {
-          if (iCnloop == iPosLeftAbove[1])
-          {
-            iPosLeftAbove[1] = -1;
-          }
-          else
-          {
-            if (iCnloop > iPosLeftAbove[1])
-            {
-              iPosLeftAbove[1]++;
-            }
-          }
-        }
-      }
-      pcMvFieldNeighbours[iCount<<1].setMvField(tmpMV[0].getMv(), tmpMV[0].getRefIdx());
-      pcMvFieldNeighbours[(iCount<<1)+1].setMvField(tmpMV[1].getMv(), tmpMV[1].getRefIdx());
-
-      puhInterDirNeighbours[iCount] = tmpDir;
-#endif
       if ( mrgCandIdx == iCount )
       {
@@ -4763,11 +4347,7 @@
       if( tmpDir != 0 )
       {
-#if !ETRIKHU_CLEANUP_H0083
-        rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, 5-iCount, iCount3DV);
-#endif
         m_ucDDTmpDepth = m_pcSlice->getDepthFromDV( iDV,  iViewIdx );
         m_iUseDDDCandIdx = iCount;
 
-#if ETRIKHU_CLEANUP_H0083
         m_mergCands[MRG_D].setCand( tmpMV, tmpDir, false, false);
         if ( mrgCandIdx == iCount )
@@ -4776,34 +4356,4 @@
         }
         iCount ++;
-#else
-        if( tmpDir == 1 )
-        {
-          pcMvFieldNeighbours[ iCount << 1 ] = tmpMV[ 0 ];
-        }
-        else if( tmpDir == 2  )
-        {
-          pcMvFieldNeighbours[( iCount << 1 ) + 1 ] = tmpMV[ 1 ];
-        }
-
-        abCandIsInter        [ iCount ] = true;
-        puhInterDirNeighbours[ iCount ] = tmpDir;
-
-        if ( mrgCandIdx == iCount )
-        {
-          return;
-        }
-        iCount ++;
-
-        Int iLeftAboveAvail = 0;
-        if( iPosLeftAbove[ 0 ] != -1 )
-        {
-          iPosLeftAbove[ 0 ] = iCount;
-          iLeftAboveAvail = 1;
-        }
-        if( iPosLeftAbove[ 1 ] != -1 )
-        {
-          iPosLeftAbove[ 1 ] = iCount + iLeftAboveAvail;
-        }
-#endif
       }
     }
@@ -4813,8 +4363,4 @@
   //////// DERIVE IvMC, IvMCShift,IvDCShift, IvDC  Candidates /////
   /////////////////////////////////////////////////////////////////
-
-#if !ETRIKHU_CLEANUP_H0083
-  Int  posIvDC          = -1;
-#endif
 
   // { IvMCL0, IvMCL1, IvDCL0, IvDCL1, IvMCL0Shift, IvMCL1Shift, IvDCL0Shift, IvDCL1Shift };  
@@ -4828,14 +4374,8 @@
   Bool ivMvPredFlag   = getSlice()->getVPS()->getIvMvPredFlag( getSlice()->getLayerIdInVps() );
 
-#if SHARP_SIMPLE_MERGE_H0062
   ivMvPredFlag &= (nPSW + nPSH > 12);
-#endif
   if ( ivMvPredFlag && cDisInfo.m_aVIdxCan!=-1)
   {
-#if SEC_ADAPT_DISABLE_IVMP
     getInterViewMergeCands(uiPUIdx, ivCandRefIdx, ivCandMv, &cDisInfo, ivCandDir , bIsDepth, pcMvFieldSP, puhInterDirSP, bICFlag );
-#else
-    getInterViewMergeCands(uiPUIdx, ivCandRefIdx, ivCandMv, &cDisInfo, ivCandDir , bIsDepth, pcMvFieldSP, puhInterDirSP );
-#endif
   }  
 
@@ -4863,8 +4403,4 @@
 
     Bool bRemoveSpa = false; //pruning
-#if !ETRIKHU_CLEANUP_H0083
-    Bool bIvMC = false;
-    Int iCnloop=0;
-#endif
 
     if (!bIsDepth)
@@ -4872,5 +4408,4 @@
       for(Int i = 0; i < 2; i ++)
       {
-#if ETRIKHU_CLEANUP_H0083
         if ( !m_mergCands[MRG_A1 + i].m_bAvailable ) // prunning to A1, B1
         {
@@ -4882,107 +4417,17 @@
           break;
         }      
-#else
-        iCnloop = iPosLeftAbove[i];
-        if ( iCnloop == -1 ) 
-        {
-          continue;
-        }
-        if(ivCandDir[0] == puhInterDirNeighbours[iCnloop] && tmpMV[0]==pcMvFieldNeighbours[(iCnloop<<1)] && tmpMV[1]==pcMvFieldNeighbours[(iCnloop<<1)+1])
-        {
-          bRemoveSpa                      = true;
-          break;
-        }      
-#endif
       }
     }
     if (bIsDepth)
     {
-#if ETRIKHU_CLEANUP_H0083
       if (m_mergCands[MRG_T].m_bAvailable && ivCandDir[0] == m_mergCands[MRG_T].m_uDir && tmpMV[0]==m_mergCands[MRG_T].m_cMvField[0] && tmpMV[1]==m_mergCands[MRG_T].m_cMvField[1])
       {
         bRemoveSpa                      = true;
       }
-#else
-      iCnloop = iCount-1;
-      for(; iCnloop >= 0; iCnloop --)
-      {
-#if H_3D_DDD
-          if( iCnloop == m_iUseDDDCandIdx )
-          {
-              continue;
-          }
-#endif
-        if(ivCandDir[0] == puhInterDirNeighbours[iCnloop] && pcMvFieldNeighbours[iCnloop<<1]==tmpMV[0] && pcMvFieldNeighbours[(iCnloop<<1)+1]==tmpMV[1])  // F0125 compatible with F0093
-        {
-          bRemoveSpa                      = true;
-          break;
-        }
-      }
-#endif
-    }
-
+    }
     if (!bRemoveSpa)
     {
-#if !ETRIKHU_CLEANUP_H0083
-      bIvMC = true;
-      rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, (5-iCount), iCount3DV);
-
-      if (iPosLeftAbove[0] != -1)
-      {
-        iPosLeftAbove[0]++;
-      }
-      if (iPosLeftAbove[1] != -1)
-      {
-        iPosLeftAbove[1]++;
-      }
-    }
-    else if (bRemoveSpa && !bIsDepth)
-    {
-      bIvMC = true;
-      rightShiftMergeCandList( pcMvFieldNeighbours, puhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, iCount, (iCnloop-iCount), iCount3DV);
-
-      if (iCnloop<numA1B1B0)
-      {
-        numA1B1B0--;
-      }
-      iCountHEVC--;
-
-      if (iPosLeftAbove[0] != -1)
-      {
-        if (iCnloop == iPosLeftAbove[0])
-        {
-          iPosLeftAbove[0] = -1;
-        }
-        else
-        {
-          iPosLeftAbove[0]++;
-        }
-      }
-      if (iPosLeftAbove[1] != -1)
-      {
-        if (iCnloop == iPosLeftAbove[1])
-        {
-          iPosLeftAbove[1] = -1;
-        }
-        else
-        {
-          if (iCnloop > iPosLeftAbove[1])
-          {
-            iPosLeftAbove[1]++;
-          }
-        }
-      }
-    }
-
-    if (bIvMC)
-    {
-#endif
-#if ETRIKHU_CLEANUP_H0083
       Bool SPIVMPFlag = false;
-#if MTK_DIS_SPBIP8X4_H0205
       if(!m_pcSlice->getIsDepth())
-#else
-      if(!m_pcSlice->getIsDepth() && getPartitionSize(0) == SIZE_2Nx2N )
-#endif
       {
         SPIVMPFlag = true;
@@ -4991,27 +4436,6 @@
       SPIVMPFlag &= !bDBBPFlag;
 #endif
-#else
-      if(!m_pcSlice->getIsDepth() && getPartitionSize(0) == SIZE_2Nx2N )
-      {
-          pbSPIVMPFlag[iCount] = true;
-      }
-#if H_3D_DBBP
-      pbSPIVMPFlag[iCount] &= !bDBBPFlag;
-#endif
-#endif
-#if ETRIKHU_CLEANUP_H0083
+
       m_mergCands[MRG_IVMC].setCand( tmpMV, ivCandDir[0], false, SPIVMPFlag);
-#else
-      if( ( ivCandDir[0] & 1 ) == 1 )
-      {
-        pcMvFieldNeighbours[iCount<<1].setMvField( ivCandMv[ 0 ], ivCandRefIdx[ 0 ] );
-      }
-      if( ( ivCandDir[0] & 2 ) == 2 )
-      {
-        pcMvFieldNeighbours[(iCount<<1)+1].setMvField( ivCandMv[ 1 ], ivCandRefIdx[ 1 ] );
-      }
-
-      puhInterDirNeighbours[ iCount ] = ivCandDir[0];
-#endif
 
       if ( mrgCandIdx == iCount )
@@ -5031,9 +4455,5 @@
 
 #if H_3D
-#if ETRIKHU_CLEANUP_H0083
   iCount += m_mergCands[MRG_A1].m_bAvailable + m_mergCands[MRG_B1].m_bAvailable + m_mergCands[MRG_B0].m_bAvailable;
-#else
-  iCount += numA1B1B0;
-#endif
 #else
   //left
